﻿Public Class Person
    'フィールド
    Private _name As String
    Private _age As Integer
    Private _gender As String

    'プロパティ
    Public Property Name As String
        Get
            Return Me._name
        End Get
        Set(value As String)
            If value.Length = 0 Then
                Me._name = "名無しさん"
            Else
                Me._name = value
            End If
        End Set
    End Property

    Public Property Age As Integer
        Get
            Return Me._age
        End Get
        Set(value As Integer)
            If value < 0 Then
                Me._age = 0
            Else
                Me._age = value
            End If
        End Set
    End Property

    Public Property Gender As String
        Get
            Return Me._gender
        End Get
        Set(value As String)
            If value = "m" Or value = "f" Then
                Me._gender = value
            Else
                Me._gender = "m"
            End If
        End Set
    End Property

    'コンストラクタ
    Public Sub New(name As String, age As Integer, gender As String)
        Me.Name = name
        Me.Age = age
        Me.Gender = gender
    End Sub

    'メソッド
    Public Function SelfIntroduction() As String
        Return "わたしは" + Me._name & "、" & Me._age & "才、" & If(Me._gender = "m", "男性", "女性") & "です。"
    End Function

    Public Function SelfIntroduction(message As String) As String
        Return message & vbCrLf & Me.SelfIntroduction()
    End Function

    'Public Sub Init(name As String, age As Integer, gender As String)
    '    Me._name = name
    '    Me._age = age
    '    Me._gender = gender
    'End Sub

    Public Sub AddAge()
        Me._age += 1
    End Sub

End Class
